d = int(raw_input('Input d: '))
o = open('master_out.txt','w')
o.write("d: "+str(d)+"\n")

v = floor(d/2)-1

######################################################################
# Definition of f(m,n,t1, ... , tv)                                  #
######################################################################

# input:  beta
# output: |beta|
def asum(beta):
    return sum(beta[0]+beta[1])

# input:  beta
# output: ||beta||
def anorm(beta):
    return sum([beta[0][i-2]*i+beta[1][i-2]*(d-i) for i in range(2,v+2)])

# index set constructor for f
# note: we only need beta with ||beta|| <= d
#       so beta_1,i <= d/i and beta_2,i <= 2

def helper(i):
    if i==1:
        return [ [[],[]] ]
    return [[beta[0]+[beta_1i],beta[1]+[beta_2i]] for beta in helper(i-1) for beta_1i in range(floor(d/i)+1) for beta_2i in [0,1,2]]

indexset = [beta for beta in helper(v+1) if anorm(beta)<= d]

R = PolynomialRing(QQ,['m','n']+['ell'+str(i+2) for i in range(v)])
R.inject_variables()

f = sum([(-1)^asum(beta) * prod([binomial(R('ell'+str(i)),beta[0][i-2])*binomial(R('ell'+str(i)),beta[1][i-2]) for i in range(2,v+2)]) * binomial(m+d-anorm(beta),d-anorm(beta)) for beta in indexset]) - (n-m)*(m+1)

######################################################################
# Compute bound till which we need to check                          #
######################################################################

def tildefy(poly):
    return sum([poly.coefficients()[k]*poly.monomials()[k]([m,n]+[0 for i in range(v)]) for k in range(len(poly.coefficients())) if poly.coefficients()[k]>=0])+sum([poly.coefficients()[k]*poly.monomials()[k]([m,n]+[m for i in range(v)]) for k in range(len(poly.coefficients())) if poly.coefficients()[k]<0])

S.<x> = PolynomialRing(CC,1)

def highest_root(poly):
    roots = [-tmp[0](0) for tmp in poly.factor()]
    return max([rt for rt in roots if rt.is_real()])

# We split into case depending of which part of Lemma A.3 is used.
if d<=5:
    w = d+2

    # bound from Lemma A.3
    bound_A3 = ceil(max(d^(d-1),factorial(d-1)^((d-1)/(d-3)))/factorial(d))

    # bound from highest root of gtilde_n,d  
    g_nd = f - f(m-1,n,ell2-1) + n - 1 # added -1 to check strict inequality
    gtilde_nd = tildefy(g_nd)
    xstar = highest_root(gtilde_nd(x,n,0) - (x+w-1)^(d-1) / factorial(d))
    boundm = ceil(xstar) 
    bound_gnd = ceil((xstar+w-1)^(d-1)/factorial(d))

    boundn = max(bound_A3,bound_gnd)
else:
    w = d/2+1

    # bound from Lemma A.3
    bound_A3 = ceil(max(d^(d-1),(factorial(d)/(d/2-1)^2)^((d-1)/(d-4)))/factorial(d))

    # bounds from highest roots of gtilde_n,d,j and gtilde_n,d
    xxstar = []
    for j in range(3,v+2):
        g_ndj = f([m,n]+[R('ell'+str(i)) for i in range(2,j+1)]+[0 for i in range(j+1,v+2)]) - f([m,n]+[R('ell'+str(i)) for i in range(2,j-1)]+[R('ell'+str(j-1))+1,R('ell'+str(j))-1]+[0 for i in range(j+1,v+2)]) - 1 # added -1 to check strict inequality
        gtilde_ndj = tildefy(g_ndj)
        xxstar = xxstar + [highest_root(gtilde_ndj([x,n]+[0 for i in range(v)]))]
    g_nd = f([m,n,ell2]+[0 for i in range(1,v)]) - f([m-1,n,ell2-1]+[0 for i in range(1,v)]) + n - 1 # added -1 to check strict inequality
    gtilde_nd = tildefy(g_nd)
    xxstar = xxstar + [highest_root(gtilde_nd([x,n]+[0 for i in range(v)]))]  
    xstar = max(xxstar)
    boundm = ceil(xstar)
    bound_gnd = ceil((xstar+w-1)^(d-1)/factorial(d))
    
    boundn = max(bound_A3,bound_gnd)

print "bound for n is", boundn
o.write("bound for n is "+str(boundn)+"\n")
print "bound for m is", boundm
o.write("bound for m is "+str(boundm)+"\n")
o.close()

######################################################################
# Create worker.py                                                   #
######################################################################

input = open('worker_template.py', 'r')
L = input.readlines()
L[5] = 'd = '+str(d)+"\n"
L[6] = 'v = '+str(v)+"\n"
L[7] = 'N = '+str(boundn)+"\n"
L[8] = 'M = '+str(boundm)+"\n"
L[10] = '    '+str(list(R.gens()))+' = lst'+"\n"
L[11] = '    return '+str(factorial(d)*f).replace("^","**")+"\n"
o = open('worker.py','w')
for line in L:
    o.write(line)
o.close()









































